' ''''''''''''''''''''''''''''''''''''''''''
' ' Written April 2008 by Chuck Rice
' ''''''''''''''''''''''''''''''''''''''''''

con
  cScannerMaxRows = 20
  cBaud         = 115200

  more          = true
  send          = false
  maxData       = 255
  maxPacketArgs = 10
  
  packetSTX1    = $F0
  packetSTX2    = $F1
  
  packetETX1    = $F2
  packetETX2    = $F3

  cVGAstartPin   = 16
  cVGA17         = 17
  cVGA18         = 18
  cVGA19         = 19
  cVGA20         = 20
  cVGA21         = 21
  cVGA22         = 22
  cVGA23         = 23
  cMouse1        = 24
  cMouse2        = 25


''
''Screen control characters
''
  CLEAR     = $02     '' $02 = clear screen
  HOME      = $01     '' $01 = home
  BACKSPACE = $08     '' $08 = backspace
  TAB       = $09     '' $09 = tab (8 spaces per)
  SETROW    = $0B     '' $0B = set Y position (Y follows)
  SETCOLUMN = $0A     '' $0A = set X position (X follows)
  SETCOLOR  = $0C     '' $0C = set color (color follows)
  CR        = $0D     '' $0D = return
  ESC       = $1B     '' $1B = Escape

  #1                            'Packet Type Enumeration
  commandPacket
  responsePacket
  acknowledgePacket

                          
  #1                            'Packet Function Enumeration                           
  GetGPSinfo
  GetGPSinfo2
  stopMotors
  GetCogs
  sendPosition
  getScanMap
  setWayPoint
  getDistAndBearing
  doTest
  steer
  identify
  error
  debug
  
  
  #1                            ' Source and Destination Enumerations
  NavBoard
  MotBoard
  ComBoard
  SenBoard

     
  #0                            ' Packet Buffer Field Offsets
  offset_Start1                      '    Packet Start 1
  offset_Start2                      '    Packet Start 2
  offset_Length                      '    Packet Length (total length)
  offset_Source                      '    Packet Source Address
  offset_Dest                        '    Packet Destination Address
  offset_Func                        '    Packet Function
  offset_Type                        '    Packet Type
  offset_ArgCnt                      '    Packet Argument Count
  offset_Data                        '    Packet Payload
                         
  #0
  pSource                       'Packet Argument Enumeration
  pDest                         
  pArg1
  pArg2
  pArg3
  pArg4
  pArg5

  #1                            'g#GetCogs    field types
  freeCogs

  
  #1                            'g#GetGPSinfo field types
  gpsFixQuality  
  gpsSatelliteCount
  gpsAltitudeFeet
  gpsSpeedInMph
  gpsDate
  gpsTime
  gpsHeadingDegreesStr
  gpsLatitude
  gpsN_S
  gpsLongitude
  gpsE_W
  gpsHeadingCompassPoint


  cMaxCogs = 8
Pub lookupBoardName(bNumber) : bName  | n,s,iPtr,c

    case bNumber
        NavBoard :  return string("NavBoard")
        MotBoard :  return string("MotBoard")
        ComBoard :  return string("ComBoard")
        SenBoard :  return string("SenBoard")
        other      :  return string("UnknownBoard")

Pub lookupFunctionName(bNumber) : bName  | n,s,iPtr,c

    case bNumber

        GetGPSinfo        :  return string("GetGPSinfo       ")       
        GetGPSinfo2       :  return string("GetGPSinfo2      ")      
        stopMotors        :  return string("stopMotors       ")       
        GetCogs           :  return string("GetCogs          ")          
        sendPosition      :  return string("sendPosition     ")     
        getScanMap        :  return string("getScanMap       ")       
        setWayPoint       :  return string("setWayPoint      ")      
        getDistAndBearing :  return string("getDistAndBearing")
        doTest            :  return string("doTest           ")           
        steer             :  return string("steer            ")            
        identify          :  return string("identify         ")         
        error             :  return string("error            ")            
        debug             :  return string("debug            ")            
        other             :  return string("UnknownFunction  ")
         

Pub lookupTypeName(bNumber) : bName  | n,s,iPtr,c

    case bNumber
        commandPacket     :  return string("commandPacket    ")
        responsePacket    :  return string("responsePacket   ")
        acknowledgePacket :  return string("acknowledgePacket")
        other             :  return string("UnknownType      ")

pub justify(fldWidth,value) | fw
    case value
      0..9 :  fw := fldWidth-1
      10..99 :  fw := fldWidth-2
      100..999 :  fw := fldWidth-3
      1000..9999 :  fw := fldWidth-4
      10000..99999 :  fw := fldWidth-5
      100000..999999 :  fw := fldWidth-6
      1000000..9999999 :  fw := fldWidth-7
      10000000..99999999 :  fw := fldWidth-8
      100000000..999999999 :  fw := fldWidth-9
      other : fw := 0

    return fw 
   
PUB free_cogs : free | i, cog[8], jmp_0

  jmp_0 := %010111_0001_1111_000000000_000000000
  
  repeat while (cog[free] := cognew(@jmp_0, 0)) => 0 
    free++
    
  if free
    repeat i from 0 to free - 1
      cogstop(cog[i])
      
  return free

pub concatStr(dest,s1,s2)
'' Concatonates two strings and stores the result in 'dest'
'' Example call:   concatStr(@commBuff,string("hiya-"),string("toots"))

    bytemove(dest,s1,strsize(s1))
    bytemove(dest+strsize(s1),s2,strsize(s2))

pub hexLookup(key)

  case key
   "0": return 0
   "1": return 1
   "2": return 2
   "3": return 3 
   "4": return 4
   "5": return 5
   "6": return 6
   "7": return 7
   "8": return 8
   "9": return 9
   "A": return 10
   "B": return 11
   "C": return 12
   "D": return 13
   "E": return 14
   "F": return 15
   
pub xHex2Bin(binBasePtr,hexBasePtr,elements) | hexOffset,binOffset
  binOffset := 0
  hexOffset := 0
  
  repeat 
      byte[binBasePtr][binOffset] := (hexLookup(byte[hexBasePtr][hexOffset++])<<4) + hexLookup(byte[hexBasePtr][hexOffset++])
  while binOffset++ < elements


pub xBin2Hex(hexBasePtr,binBasePtr,elements) | hexOffset,binOffset,value

  binOffset := 0
  hexOffset := 0
  
  repeat
    value := byte[binBasePtr][binOffset]
    value <<= 6 << 2
    byte[hexBasePtr][hexOffset++] := lookupz((value <-= 4) & $F : "0".."9", "A".."F")
    byte[hexBasePtr][hexOffset++] := lookupz((value <-= 4) & $F : "0".."9", "A".."F")
  while binOffset++ < elements

 byte[hexBasePtr][hexOffset++] := 0 

   
     
    
  

 